/*
	Serial Camera Client 
	Version 11/24/2010-A
	(C) 2010 Jason Hunt nulluser@gmail.com

	This program is free software; you can redistribute it and/or
    	modify it under the terms of the GNU General Public License
    	as published by the Free Software Foundation; either version 2
    	of the License, or (at your option) any later version.

    	This program is distributed in the hope that it will be useful,
    	but WITHOUT ANY WARRANTY; without even the implied warranty of
    	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    	GNU General Public License for more details.

    	You should have received a copy of the GNU General Public License
    	along with this program; if not, write to the Free Software
    	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/


#ifndef CAMERA_H
#define CAMERA_H

class camera_class
{
public:
    camera_class( unsigned char id );

    ~camera_class();

    int camera_class::camera_start_image(void);
    int camera_class::camera_stop_image();
    int camera_class::camera_get_block(unsigned int &addr, unsigned int len, 
                                       unsigned char *buff);
    int camera_class::camera_get_filesize(unsigned int &size);
    int camera_class::camera_set_size( int image_size );
    int camera_class::camera_set_baud( void );

    void camera_class::camera_reset();

    void camera_class::camera_setup_image(int image_size);

    int camera_class::camera_get_image( unsigned char *buff, unsigned int &image_size );


    static DWORD WINAPI camera_class::camera_thread(LPVOID p);
 
    void camera_class::camera_start( void );

    void camera_class::camera_stop ( void );

    int camera_class::runProcess (void* pThis);


    int camera_class::Process ();

    static DWORD camera_class::ThreadProc(LPVOID pvoid) ;

    unsigned char device_id ;

HANDLE h_camera_thread ;               // Handel for serial control thread
DWORD camera_thread_id;               // Serial control 
bool camera_running;          // True if serial thread is running

CRITICAL_SECTION camera_thread_lock;  // Lock for serial thread



};


extern camera_class camera;
extern camera_class camera2;


#endif
