/*
	Serial Camera Client 
	Version 11/24/2010-A
	(C) 2010 Jason Hunt nulluser@gmail.com

	This program is free software; you can redistribute it and/or
    	modify it under the terms of the GNU General Public License
    	as published by the Free Software Foundation; either version 2
    	of the License, or (at your option) any later version.

    	This program is distributed in the hope that it will be useful,
    	but WITHOUT ANY WARRANTY; without even the implied warranty of
    	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    	GNU General Public License for more details.

    	You should have received a copy of the GNU General Public License
    	along with this program; if not, write to the Free Software
    	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/




#include <stdlib.h>
#include <stdio.h>
#include <windows.h>

#include "display.h"
#include "window.h"
#include "main.h"
#include "types.h"
#include "image.h"

#include "window.h"

#include "log.h"

#include "timer.h"

unsigned int display_x  =  640;                     // Sample ares size in pixels
unsigned int display_y  =  480;

static char text_area[text_y_size][text_x_size];  // Data for text display
        
        
HDC memdc = NULL;	           	           // Memory device context
HBITMAP h_mem_bitmap = NULL;                // Offscreen bitmap
        
//FILE *log = fopen("log.txt", "wt");

bool display_fps =false;

/* Display the text area */
void display_text( HDC hdc )
{
    // Clear the old text area
    Rectangle(hdc, 0, display_y, display_x, display_y +  text_area_height+2);
        
    // Draw text lines
    for (unsigned int r = 0; r < text_y_size; r++)
        TextOut(hdc, 2, r * font_y_size + display_y + 1, text_area[r], strlen(text_area[r]));
}
/* End if display_text */



/* Show the text buffer on the screen */
void update_display(HWND hwnd)
{
    SelectObject(memdc, (HBRUSH) GetStockObject(WHITE_BRUSH));
    SelectObject(memdc, (HBRUSH) GetStockObject(WHITE_PEN));    
   
/*    RECT r;

    GetClientRect(hwnd, &r);

    // Clear old offscreen buffer
    Rectangle(memdc, 0, 0, r.right, r.bottom);*/




    StretchDIBits(memdc, 0, 0, display_x, display_y, 
                         0, 0, image_x_size, image_y_size, 
                         image_buffer,    &image_buffer_info,
                         DIB_RGB_COLORS, SRCCOPY);
      
      

      
      
   // if (display_fps)
    {
        // Display text information
        char b[400];
        sprintf(b, "FPS: %3.2f", fps);
        TextOut(memdc, 2, 2, b, strlen(b));
    }



    SelectObject(memdc, (HPEN) GetStockObject(BLACK_PEN));


    display_text(memdc);

}
/* End of display_text_area */


/* Reset the text area */
void clear_text_area( void )
{
//    memset(text_area, 0x00, text_y_size * text_x_size);
}
/* End fo clear text area */


/* Adds a line to the text buffer */
void do_add_line(char *line)
{    
    static unsigned int text_y = 0; 
    
    static bool text_clear = false;
    
    if (!text_clear)
    {
        memset(text_area, 0x00, text_y_size * text_x_size);
        text_clear = true;
    }    

    // Scrool the display up
    if (text_y == text_y_size)
    {
        for (int i = 1; i < text_y_size; i++)
            memcpy(text_area[i-1], text_area[i], text_x_size);
    }
    else
        text_y ++;
    // Copy the string
    unsigned int line_len = strlen(line);

    strncpy(text_area[text_y - 1], line, text_x_size);


//fprintf(log, "%s\n", line);

    update_display(main_win);
    InvalidateRect (main_win, NULL, FALSE);
//    display_text();
}
/* End of add line */



/* Write formatted data to the debugging console */
void add_line(char *fmt, ... )
{
  
    const unsigned int max = 1024;

    va_list args;
    char text[max];

    va_start(args, fmt);
    vsnprintf(text, max, fmt, args);
    DWORD out = 0;
    
    
    do_add_line(text);

//    WriteConsole(h_console, text, strlen(text), &out, NULL);

    va_end(args);    
    
    log("%s", text);
 
}
/* End of write_console */













/* Make a color */
color_type get_color(unsigned char r, unsigned char g, unsigned char b)
{
    color_type t;
    
    t.r = r; t.b = b; t.g = g;
    
    return(t);
}
/* End of get_color */



/* Copy offscreen buffer to display */
void do_paint(HWND hwnd)
{
    PAINTSTRUCT ps;
    HDC hdc = BeginPaint(hwnd, &ps);
    BitBlt(hdc, 0, 0, window_x_size, window_y_size, memdc, 0, 0, SRCCOPY);
    EndPaint(hwnd, &ps);  
}
/* End of do_paint */


/* Create off screen buffer */
void display_setup( HWND hwnd )
{
    // Get main DC
    HDC hdc = GetDC(hwnd);

  	// Create Memory device contextand bitmap
    memdc = CreateCompatibleDC(hdc);	

    // Create off screen buffer
  	h_mem_bitmap = CreateCompatibleBitmap(hdc, window_x_size, window_y_size);

  	// Select the off screen buffer into the DC
   	SelectObject(memdc, h_mem_bitmap);		

    ReleaseDC(hwnd, hdc);       // Main DC is no longer needed
}
/* End of setup_display */







/* Resize the display and update buffers */
void display_buffer_resize(HWND hwnd, LPARAM l)
{


    window_x_size = LOWORD(l);
    window_y_size = HIWORD(l);
    


    display_x = window_x_size;
    display_y = window_y_size  - text_area_height - 2;// - 10;

    DeleteObject(h_mem_bitmap);		//	 Delete old screen buffer
    DeleteDC(memdc);		      	// Delete old memory DC

    display_setup(hwnd);

    InvalidateRect(hwnd, NULL, true);   
}
/* End of resize_display */





/* Called when windows is resized to modify the display area size */
void display_resize( void )
{
/*    WINDOWPLACEMENT p;                      // Holds window data

    p.length = sizeof(WINDOWPLACEMENT);     // Setup struct
    GetWindowPlacement(main_win, &p);       // Get window information
        
    display_x = image_x_size + extra_display_width; //+ 12;
    display_y = image_y_size + text_area_height + 34;
        
    p.rcNormalPosition.right = p.rcNormalPosition.left + display_x;
    p.rcNormalPosition.bottom= p.rcNormalPosition.top + display_y;
            
    SetWindowPlacement(main_win, &p);*/
}
/* End of display_resize */








