/*
	Serial Camera Client 
	Version 11/24/2010-A
	(C) 2010 Jason Hunt nulluser@gmail.com

	This program is free software; you can redistribute it and/or
    	modify it under the terms of the GNU General Public License
    	as published by the Free Software Foundation; either version 2
    	of the License, or (at your option) any later version.

    	This program is distributed in the hope that it will be useful,
    	but WITHOUT ANY WARRANTY; without even the implied warranty of
    	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    	GNU General Public License for more details.

    	You should have received a copy of the GNU General Public License
    	along with this program; if not, write to the Free Software
    	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/


#ifndef DISPLAY_H
#define DISPLAY_H

#include <windows.h>
#include "types.h"


#define MIN_TEXT_Y  198            // The text box will start no lower than this

#define extra_display_width 200

#define text_x_size 200           // Number of text colums
#define text_y_size 12            // Nuumber of text rows

#define font_x_size 8            // Font size in pixels
#define font_y_size 16           // Font y_size in pixels

#define text_area_height  (text_y_size*font_y_size + 4)  // Size of text area
#define text_area_width   (text_x_size*font_x_size + 4) 

#define sonar_bar_size   8


void update_display(HWND hwnd);          // Display frame buffer and text into

void add_line(char *fmt, ... );

void do_paint(HWND hwnd);
void display_resize( void );
void display_buffer_resize(HWND hwnd, LPARAM l);


extern unsigned int display_x;
extern unsigned int display_y;
extern bool display_fps;

#endif



