/*
	Serial Camera Client 
	Version 11/24/2010-A
	(C) 2010 Jason Hunt nulluser@gmail.com

	This program is free software; you can redistribute it and/or
    	modify it under the terms of the GNU General Public License
    	as published by the Free Software Foundation; either version 2
    	of the License, or (at your option) any later version.

    	This program is distributed in the hope that it will be useful,
    	but WITHOUT ANY WARRANTY; without even the implied warranty of
    	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    	GNU General Public License for more details.

    	You should have received a copy of the GNU General Public License
    	along with this program; if not, write to the Free Software
    	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/



#include <windows.h>
#include <stdio.h>


#include "log.h"
#include "timer.h"

static FILE *log_file = fopen("log.txt", "wt");

/* Write formatted data to the debugging console */
void console(char *fmt, ... )
{
    static HANDLE h_console = INVALID_HANDLE_VALUE;

    if (h_console == INVALID_HANDLE_VALUE)
    {
        AllocConsole();
        h_console =  GetStdHandle(STD_OUTPUT_HANDLE); 
     }
   
    const unsigned int max = 1024;

    va_list args;
    char text[max];

    va_start(args, fmt);
    vsnprintf(text, max, fmt, args);
    DWORD out = 0;

    WriteConsole(h_console, text, strlen(text), &out, NULL);

    va_end(args);    
    
    log("%s", text);
 
}
/* End of write_console */

/* Write formatted data to the debugging console */
void log(char *fmt, ... )
{
    static double start_time = get_time();


    const unsigned int max = 30000;

    va_list args;
    char text[max];

    fprintf(log_file, "[%4.2f] ",  get_time() - start_time);



    va_start(args, fmt);
    vsnprintf(text, max, fmt, args);
    fprintf(log_file, "%s", text);

    va_end(args);    
 
    fprintf(log_file, "\n", text);
}


void log_stop( void )
{
    fclose(log_file);
}



